#ifndef parser_h
#define parser_h

#include <stdio.h>
#include "../../mem/mem.h"
#include "text_ops.h"

struct media_info {
  str src_host;
  int src_port;
  str src_port_str;
  str dst_host;
  int dst_port;
  str dst_port_str;

  struct media_info *next; /* For future use */
  struct media_info *before; /* For future use */
};

struct fcp_info {
  str sent_host; /* The IP address of the host in the request*/
  str sent_rtp_port; /* Where the media is expected in the request */
  str sent_rtcp_port; /* Control channel for media in the request */
  str rpl_host; /* The IP address on the fcp reply */
  str rpl_rtp_port; /* Port for media assigned by nat */
  str rpl_rtcp_port; /* Control channel for media assigned by nat */  
  int seq; /* To identify the transaction */

  struct fcp_info *next; /* For future use */
  struct fcp_info *before;  /* For future use */
};

int parse_media_info(struct sip_msg *request, struct sip_msg *reply, struct media_info *media);

int parse_fcp_info(char *s, struct fcp_info *rpl, struct media_info *sent);

int is_method(char *message, char *method);

#endif
