/* tcpClient.c */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h> /* close */
#include <string.h>
#include "fcp_pa.h"
#include "tcpClient.h"

int openConnection(char *hostip, u_int port) {

  char *func="openConnection";
  int sd, rc;
  struct sockaddr_in localAddr, servAddr;
  struct hostent *h;
  
  h = gethostbyname(hostip);
  if(h==NULL) {
    printf("%s: unknown host '%s'\n",func, hostip);
    return -1;
  }

  servAddr.sin_family = h->h_addrtype;
  memcpy((char *) &servAddr.sin_addr.s_addr, h->h_addr_list[0], h->h_length);
  servAddr.sin_port = htons(port);

  /* create socket */
  sd = socket(AF_INET, SOCK_STREAM, 0);
  if(sd<0) {
    perror("cannot open socket ");
    return -1;
  }

  /* bind any port number */
  localAddr.sin_family = AF_INET;
  localAddr.sin_addr.s_addr = htonl(INADDR_ANY);
  localAddr.sin_port = htons(0);
  
  rc = bind(sd, (struct sockaddr *) &localAddr, sizeof(localAddr));
  if(rc<0) {
    printf("%s: cannot bind port TCP %u\n",func ,port);
    perror("error ");
    return -1;
  }

 				
  /* connect to server */
  rc = connect(sd, (struct sockaddr *) &servAddr, sizeof(servAddr));
  if(rc<0) {
    perror("cannot connect ");
    return -1;
  }

return sd;
  
}

int closeConnection(int sd) {

  char *func="closeConnection";

  /* In the future, we may want to check a database for open connections */

  if(sd<0) {
    printf("%s: Error closing socket\n", func);
    perror("Cannot close");
    return(-1);
  } 

  close(sd);

  return 0;

}
